<template>
    <nav  aria-label="Page navigation">
		<ul class="pagination">
			<li class="page-item">
				<a
					@click.prevent="onClickFirstPage"
					class="page-link"
					href="#"
					role="button"
					rel="prev"
				>
					&laquo;
				</a>
			</li>

			<li class="page-item">
				<a
					@click.prevent="onClickPreviousPage"
					:disabled="isInFirstPage"
					aria-label="Go to previous page"
					class="page-link"
					:class="{'cursor-not-allowed': isInFirstPage}"
				>Prev</a>
			</li>

			<li
				v-for="page in pages"
				class="page-item"
				:key="page.name"
			>
				<a
					class="page-link"
					href="#"
					@click.prevent="onClickPage(page.name)"
					role="button"
				>{{ page.name }}</a>
			</li>

			<li class="page-item">
				<a
					type="button"
                    class="page-link"
					@click.prevent="onClickNextPage"
					:disabled="isInLastPage"
					aria-label="Go to next page"
					:class="{'cursor-not-allowed': isInLastPage}"
				>Next</a>
			</li>

			<li class="page-item">
				<a
					class="page-link"
					href="#"
					@click.prevent="onClickLastPage"
					rel="next"
					role="button"
					v-if="hasMorePages"
				>&raquo;</a>
				<span
					class="rounded-r rounded-sm px-3 py-2 hover:bg-gray-100 text-gray-600 no-underline cursor-not-allowed"
					v-else
				>&raquo;</span>
			</li>
		</ul>
	</nav>
</template>

<script>
    export default {
        name: 'Pagination',
        props: {
            maxVisibleButtons: {
                type: Number,
                required: false,
                default: 5
            },

            totalPages: {
                type: Number,
                required: true
            },

            total: {
                type: Number,
                required: true
            },

            perPage: {
                type: Number,
                required: true
            },

            currentPage: {
                type: Number,
                required: true
            },

            hasMorePages: {
                type: Boolean,
                required: true
            }
        },
        computed: {
            startPage() {
                if (this.currentPage === 1) {
                    return 1;
                }

                if (this.currentPage === this.totalPages) {
                    if (this.totalPages <= this.maxVisibleButtons) {
                        return 1;
                    }
                    return this.totalPages - this.maxVisibleButtons + 1;
                }

                return this.currentPage - 1;
            },
            endPage() {
                return Math.min(
                    this.startPage + this.maxVisibleButtons - 1,
                    this.totalPages
                );
            },
            pages() {
                const range = [];

                for (let i = this.startPage; i <= this.endPage; i += 1) {
                    range.push({
                        name: i,
                        isDisabled: i === this.currentPage
                    });
                }

                return range;
            },
            isInFirstPage() {
                return this.currentPage === 1;
            },
            isInLastPage() {
                return this.currentPage === this.totalPages;
            }
        },
        methods: {
            onClickFirstPage() {
                this.$emit("pagechanged", 1);
            },
            onClickPreviousPage() {
                this.$emit("pagechanged", this.currentPage - 1);
            },
            onClickPage(page) {
                this.$emit("pagechanged", page);
            },
            onClickNextPage() {
                this.$emit("pagechanged", this.currentPage + 1);
            },
            onClickLastPage() {
                this.$emit("pagechanged", this.totalPages);
            },
            isPageActive(pageName) {
                return this.currentPage === pageName;
            }
        }
    }
</script>
